/*
 * Copyright (c) 2018-2999 广州市蓝海创新科技有限公司 All rights reserved.
 *
 * https://www.mall4j.com/
 *
 * 未经允许，不可做商业用途！
 *
 * 版权所有，侵权必究！
 */

package com.qs.mp.web.controller.api.channel;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.parser.Feature;
import com.alibaba.fastjson.serializer.SerializerFeature;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.eptok.yspay.opensdkjava.fund.BankAuthorityApi;
import com.eptok.yspay.opensdkjava.pojo.vo.OnlineReqDataVo;
import com.eptok.yspay.opensdkjava.util.DateUtil;
import com.eptok.yspay.opensdkjava.util.SrcDesUtil;
import com.eptok.yspay.opensdkjava.util.YsOnlineSignUtils;
import com.qs.mp.channel.domain.Channel;
import com.qs.mp.channel.domain.ChannelBank;
import com.qs.mp.channel.domain.ChannelBankCard;
import com.qs.mp.channel.domain.ChannelCart;
import com.qs.mp.channel.domain.ChannelWithdraw;
import com.qs.mp.channel.domain.param.ChannelBankCardCreateParam;
import com.qs.mp.channel.domain.param.ChannelCartParam;
import com.qs.mp.channel.domain.param.ChannelWithdrawParam;
import com.qs.mp.channel.domain.vo.ChannelCartVO;
import com.qs.mp.channel.domain.vo.ChannelOrderSettleVO;
import com.qs.mp.channel.service.IChannelBankCardService;
import com.qs.mp.channel.service.IChannelCartService;
import com.qs.mp.channel.service.IChannelService;
import com.qs.mp.channel.service.IChannelWithdrawService;
import com.qs.mp.common.constant.YsPayMethodConstants;
import com.qs.mp.common.constant.YsServerApiConstants;
import com.qs.mp.common.core.domain.AjaxResult;
import com.qs.mp.common.core.redis.RedisCache;
import com.qs.mp.common.domain.YsCallLog;
import com.qs.mp.common.domain.param.BatchLongIdsParam;
import com.qs.mp.common.enums.ChannelStatusEnum;
import com.qs.mp.common.enums.YsCallBizTypeEnum;
import com.qs.mp.common.service.IYsCallLogService;
import com.qs.mp.common.utils.StringUtils;
import com.qs.mp.common.utils.http.OkHttpUtil;
import com.qs.mp.system.service.ISysConfigService;
import com.qs.mp.utils.SecurityUtils;
import com.qs.mp.web.controller.common.BaseApiController;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.annotations.ApiOperation;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.concurrent.TimeUnit;
import javax.validation.Valid;
import lombok.AllArgsConstructor;
import ma.glasnost.orika.MapperFacade;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;


@RestController
@RequestMapping("/api/v1/mp/channel")
@Api(tags = "渠道提现接口")
public class ChannelWithdrawController extends BaseApiController {


  @Autowired
  private IChannelWithdrawService channelWithdrawService;

  @Autowired
  private IChannelService channelService;

  @Autowired
  private IChannelBankCardService channelBankCardService;

  @Autowired
  private RedisCache redisCache;

  private final String CHANNEL_WITHDRAW_CACHE_KEY = "channel_settle_withdraw_";

  @Autowired
  private ISysConfigService configService;

  /**
   * 提现费率配置key
   */
  private final String FEE_RATE_CONFIG_KEY = "channel.withdraw.feeRate";
  /**
   * 提现费率默认值
   */
  private final String FEE_RATE_DEFAULT_VALUE = "0.8";


  @Value("${ys-pay.partner-id}")
  private String partnerId;

  @Value("${ys-pay.private-key-pass}")
  private String privateKeyPass;

  @Value("${ys-pay.private-key-path}")
  private String privateKeyPath;

  @Value("${ys-pay.public-key-path}")
  private String publicKeyPath;

  @Autowired
  private IYsCallLogService ysCallLogService;

//  @ApiOperation(value = "银行卡实名认证绑定")
//  @PostMapping("/withdraw/bankCardAuth")
//  public AjaxResult bankCardAuth(@Validated @RequestBody ChannelBankCardCreateParam param) {
//    Long channelId = SecurityUtils.getLoginUser().getChannelId();
//
//    // 判断是否已经绑定过银行卡
//    int count = channelBankCardService.count(new LambdaQueryWrapper<ChannelBankCard>()
//        .eq(ChannelBankCard::getChannelId, channelId));
//    if (count > 0) {
//      return AjaxResult.error("已经绑定过银行卡");
//    }
//
//
//    OnlineReqDataVo req = new OnlineReqDataVo();
//    //商户在银盛支付平台开设的用户号[商户号],接入时需要替换成自己的
//    req.setPartnerId(partnerId);
//    req.setReqUrl(YsServerApiConstants.OPEN_API);
//    req.setPrivateKeyFilePath(privateKeyPath);
//    req.setPrivateKeyPassword(privateKeyPass);
//    req.setYsPublicKeyFilePath(publicKeyPath);
//    //银行实名认证三要素下单业务参数
//    Map<String, Object> bizContent = new HashMap<>();
//    String tradeNo = DateUtil.getDateNowYmd() + DateUtil.getRandom(14);
//    //商户生成的订单号，生成规则前8位必须为交易日期，如20180525，范围跨度支持包含当天在内的前后一天
//    bizContent.put("out_trade_no", tradeNo);
//    //商户日期(该参数做交易与查询时需要一致)该日期需在当日的前后一天时间范围之内
//    bizContent.put("shopdate", DateUtil.getDateNowYmd());
//    //实名认证姓名--请填写真实信息
//    bizContent.put("bank_account_name", param.getUserName());
//    //银行帐号，支持对公对私
//    bizContent.put("bank_account_no", param.getCardNo());
//    //证件号码，目前只支持身份证
//    bizContent.put("id_card", param.getIdCard());
//    req.setParamData(bizContent);
//    String result = null;
//    try{
//      logger.info("银行实名认证三要素调用sdk接口addScanMerc请求入参为:"+ JSONObject.toJSONString(req));
//      //根据返回结果处理自己的业务逻辑,result内容详见接口文档
//      result = BankAuthorityApi.sendBankAuthThreePrecise(req);
//    }catch (Exception e){
//      logger.info("银行实名认证三要素失败:"+ e.getMessage());
//    }
//    logger.info("银行实名认证三要素result =" + result);
//
////    Map<String, String> mapData = new HashMap<>();
////    mapData.put("partner_id", partnerId);
////    mapData.put("method", YsPayMethodConstants.BANK_CARD_AUTH_METHOD);
////    mapData.put("timestamp", DateUtil.getDateNow());
////    mapData.put("sign_type", "RSA");
////    mapData.put("charset", "utf-8");
////    mapData.put("version", "3.0");
////
////    JSONObject json = new JSONObject();
////    String tradeNo = DateUtil.getDateNowYmd() + DateUtil.getRandom(14);
////    json.put("out_trade_no", tradeNo);
////    json.put("shopdate", DateUtil.getDateNowYmd());
////    json.put("bank_account_name", param.getUserName());
////    json.put("bank_account_no", param.getCardNo());
////    json.put("id_card", param.getIdCard());
////    mapData.put("biz_content", json.toString());
////    //参数签名
////    try {
////      String sign = YsOnlineSignUtils.sign(mapData, privateKeyPass, privateKeyPath);
////      mapData.put("sign", sign);
////      logger.info("认证信息签名成功,sign = " + sign);
////    } catch (Exception e) {
////      System.err.println("签名异常" + e);
////    }
////
////    String result = null;
////    try {
////      logger.info("银行实名认证三要素调用sdk接口addScanMerc请求入参为:"+ JSONObject.toJSONString(mapData));
////      result = OkHttpUtil.post("https://openapi.ysepay.com/gateway.do", mapData);
////    } catch (Exception e) {
////      logger.info("银行实名认证三要素失败:"+ e.getMessage());
////
////    }
//
//    // 解析结果
////    JSONObject jsonObject = JSON.parseObject(result, Feature.OrderedField);
////    // 加签内容
////    String content = JSONObject.toJSONString(
////        jsonObject.get("ysepay_authenticate_three_key_element_precise_response"),
////        SerializerFeature.WriteMapNullValue);
////    JSONObject contentJsonObject = JSON.parseObject(content);
////
////    // 校验结果
////    String orderStatus = (String) contentJsonObject.get("order_status");
////    if (StringUtils.isBlank(orderStatus) || !"SUCCESS".equals(orderStatus)) {
////      return AjaxResult.error("绑卡认证失败,请核实信息正确性");
////    }
//
//
//    // 保存银行认证的请求记录
//    YsCallLog ysCallLog = new YsCallLog();
//    ysCallLog.setBizId(tradeNo);
//    ysCallLog.setBizType(YsCallBizTypeEnum.BANK_CARD_AUTH);
//    ysCallLog.setInterfaceId(YsPayMethodConstants.BANK_CARD_AUTH_METHOD);
//    ysCallLog.setReqJson(JSONObject.toJSONString(bizContent));
//    ysCallLog.setResJson(result);
//    ysCallLogService.save(ysCallLog);
//
//    if (StringUtils.isBlank(result)) {
//      logger.error("银行实名认证三要素失败,res为空,req =" + JSONObject.toJSONString(bizContent));
//      return AjaxResult.error("认证失败");
//    }
//
//    // 校验结果
//    JSONObject response = JSONObject.parseObject(result);
//    String orderStatus = (String) response.get("order_status");
//    if (StringUtils.isBlank(orderStatus) || !"SUCCESS".equals(orderStatus)) {
//      return AjaxResult.error("绑卡认证失败,请核实信息正确性");
//    }
//
//    // 进行绑卡
//    ChannelBankCard channelBankCard = new ChannelBankCard();
//    channelBankCard.setChannelId(channelId);
//    channelBankCard.setBankName(param.getBankName());
////    channelBankCard.setIdCard(param.getIdCard());
//    channelBankCard.setCardNo(param.getCardNo());
//    channelBankCard.setUserName(param.getUserName());
//    boolean res = channelBankCardService.save(channelBankCard);
//    if (!res) {
//      return AjaxResult.error("绑卡失败");
//    }
//    return AjaxResult.success();
//  }


  /**
   * 渠道提现计算手续费
   */
  @PostMapping("/withdraw/settle")
  @ApiOperation(value = "提现" , notes = "提现计费")
  public AjaxResult settle(@Valid @RequestBody ChannelWithdrawParam param) {
    String feeRateValue = configService.selectConfigByKey(FEE_RATE_CONFIG_KEY);
    BigDecimal feeRate = new BigDecimal(
        StringUtils.isNotBlank(feeRateValue) ? feeRateValue : FEE_RATE_DEFAULT_VALUE);
    Long channelId = SecurityUtils.getLoginUser().getChannelId();
    Channel channel = channelService.getById(channelId);
    if (channel.getStatus() == ChannelStatusEnum.OFF) {
      return AjaxResult.error("账号异常");
    }
    if (param.getMoney() > channel.getMoney() ) {
      return AjaxResult.error("提现金额超出了余额");
    }
//    if (param.getMoney() < 500) {
//      return AjaxResult.error("提现金额不能小于5元");
//    }
    int feeAmt = new BigDecimal(param.getMoney()).multiply(feeRate)
        .divide(new BigDecimal(100), 0, RoundingMode.HALF_UP).intValue();
    ChannelWithdraw channelWithdraw = new ChannelWithdraw();
    if (param.getMoney() + feeAmt > channel.getMoney()) {
      channelWithdraw.setMoney(new BigDecimal(channel.getMoney()).divide(new BigDecimal(1).add(feeRate.divide(new BigDecimal(100), 4, RoundingMode.HALF_UP)), 0, RoundingMode.HALF_UP).intValue());
      channelWithdraw.setChargeAmt(channel.getMoney() - channelWithdraw.getMoney());
    } else {
      channelWithdraw.setMoney(param.getMoney());
      channelWithdraw.setChargeAmt(feeAmt);
  }
    channelWithdraw.setUserName(param.getUserName());
    channelWithdraw.setCardNo(param.getCardNo());
    channelWithdraw.setBankName(param.getBankName());
    channelWithdraw.setBranchName(param.getBranchName());

    // 缓存订单结算对象
    redisCache.setCacheObject(CHANNEL_WITHDRAW_CACHE_KEY + channelId, channelWithdraw, 1, TimeUnit.MINUTES);

    JSONObject jsonObject = new JSONObject();
    jsonObject.put("withdrawAmt", channelWithdraw.getMoney());
    jsonObject.put("chargeAmt", channelWithdraw.getChargeAmt());
    jsonObject.put("chargeRate", feeRate);
    return AjaxResult.success(jsonObject);
  }

  /**
   * 渠道提现申请提交
   */
  @PostMapping("/withdraw/apply")
  @ApiOperation(value = "提交提现申请" , notes = "确认服务费后提交")
  public AjaxResult apply(@RequestBody ChannelWithdrawParam param) {
    Long channelId = SecurityUtils.getLoginUser().getChannelId();
    ChannelWithdraw channelWithdraw = redisCache.getCacheObject(CHANNEL_WITHDRAW_CACHE_KEY + channelId);
    if (null == channelWithdraw) {
      return AjaxResult.error("申请已过期，请重新提交");
    }
    Channel channel = channelService.getById(channelId);
    if (channelWithdraw.getMoney() + channelWithdraw.getChargeAmt() > channel.getMoney() ) {
      return AjaxResult.error("提现金额超出账户余额");
    }

    channelWithdraw.setChannelId(channelId);
    channelWithdraw.setAvailableMoney(channel.getMoney());

    channelWithdrawService.apply(channel, channelWithdraw);

    // 缓存提现结算对象
    redisCache.deleteObject(CHANNEL_WITHDRAW_CACHE_KEY + channelId);

    return AjaxResult.success("提现申请成功");
  }

  /**
   * 渠道提现查询银行卡
   */
  @PostMapping("/withdraw/card/query")
  @ApiOperation(value = "查询银行卡" , notes = "查询银行卡信息")
  public AjaxResult queryCard(@RequestBody ChannelWithdrawParam param) {
    Long channelId = SecurityUtils.getLoginUser().getChannelId();
    ChannelBankCard bankCard = channelBankCardService.getOne(new LambdaQueryWrapper<ChannelBankCard>()
        .eq(ChannelBankCard::getChannelId, channelId));

    return AjaxResult.success(bankCard);
  }
}
