package com.qs.mp.common.enums;

import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.annotation.JSONType;
import com.baomidou.mybatisplus.annotation.IEnum;
import com.qs.mp.common.json.EnumValueDeserializer;

/**
 * 分账状态枚举
 * @author Evan
 * @date 2023/3/30
 */
@JSONType(deserializer = EnumValueDeserializer.class)
public enum DivisionStatusEnum implements IEnum<Integer> {

    INIT(0,"初始化"),
    COMPLETE(1,"完成"),
    SUBMIT_FAIL(2,"登记失败"),
    FAIL(3,"失败");


    private final int value;
    private final String desc;

    DivisionStatusEnum(final int value, final String desc) {
        this.value = value;
        this.desc = desc;
    }

    @Override
    public Integer getValue() {
        return value;
    }

    /**
     * 重写toString，单个转化成json
     * @return
     */
    @Override
    public String toString() {
        JSONObject object = new JSONObject();
        object.put("value",value);
        object.put("desc", desc);
        return object.toString();
    }
}
