package com.qs.mp.common.enums;

import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.annotation.JSONType;
import com.baomidou.mybatisplus.annotation.IEnum;
import com.qs.mp.common.json.EnumValueDeserializer;

/**
 * 盈盛调用业务类型枚举
 * @author Evan
 * @date 2023/3/30
 */
@JSONType(deserializer = EnumValueDeserializer.class)
public enum YsCallBizTypeEnum implements IEnum<Integer> {

    ORDER_PAY(1,"订单支付"),

    DIVISION(2,"分账"),


    BANK_CARD_AUTH(3, "银行实名认证三要素"),

    WITHDRAW(4,"提现")

    ;


    private final int value;
    private final String desc;

    YsCallBizTypeEnum(final int value, final String desc) {
        this.value = value;
        this.desc = desc;
    }

    @Override
    public Integer getValue() {
        return value;
    }

    /**
     * 重写toString，单个转化成json
     * @return
     */
    @Override
    public String toString() {
        JSONObject object = new JSONObject();
        object.put("value",value);
        object.put("desc", desc);
        return object.toString();
    }
}
