package com.qs.mp.admin.domain.param;

import com.qs.mp.admin.domain.CdKeyGroupGoods;
import com.qs.mp.common.enums.ValidityPeriodEnum;
import lombok.Data;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import javax.validation.constraints.NotNull;
import java.util.List;

/**
 * @author zhangkaikai
 * @create 2023-05-16 10:31 AM
 **/
@ApiModel(value = "兑换码生成参数")
@Data
public class CdKeyCreateParam {

    @ApiModelProperty(value = "渠道id", required = true)
    private Long channelId;

    @ApiModelProperty(value = "兑换码组标题",required = true)
    private String title;

    @NotNull(message = "数量不能为空")
    @ApiModelProperty(value = "数量", required = true)
    private Integer quantity;

    @NotNull(message = "有效期不能为空")
    @ApiModelProperty(value = "有效期", required = true)
    private ValidityPeriodEnum validityPeriod;

    @ApiModelProperty(value = "兑换码关联商品")
    private List<CdKeyGroupGoods> goodsList;
}
