package com.qs.mp.admin.domain.param;

import com.alibaba.fastjson.annotation.JSONField;
import com.alibaba.fastjson.serializer.SerializerFeature;
import com.qs.mp.common.enums.CdKeyGroupStatusEnum;
import lombok.Data;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import java.util.Date;

/**
 * @author zhangkaikai
 * @create 2023-05-17 9:43 AM
 **/
@ApiModel("兑换码查询参数")
@Data
public class CdKeyQueryParam {

    @ApiModelProperty("兑换码名称")
    private String title;
    @ApiModelProperty("创建开始时间")
    private Date createTimeStart;
    @ApiModelProperty("创建结束时间")
    private Date createTimeEnd;
    @ApiModelProperty("激活开始时间")
    private Date activeTimeStart;
    @ApiModelProperty("激活结束时间")
    private Date activeTimeEnd;
    @ApiModelProperty("最小兑换码数量")
    private Integer minCdKeyNum;
    @ApiModelProperty("最大兑换码数量")
    private Integer maxCdKeyNum;
    @ApiModelProperty("门店id")
    private Long channelId;
    @ApiModelProperty("门店名称")
    private String siteName;
    @ApiModelProperty("状态")
    @JSONField(serialzeFeatures = SerializerFeature.WriteEnumUsingToString)
    private CdKeyGroupStatusEnum status;
}
