package com.qs.mp.admin.domain.param;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;

/**
 * @author zhangkaikai
 * @create 2023-06-05 3:27 PM
 **/
@ApiModel("门店采购商品列表查询参数")
@Data
public class ChannelGoodsOrderQueryParam {
    @ApiModelProperty(value = "商品名称", required = false)
    private String title;

    @ApiModelProperty(value = "订单编号", required = false)
    private String orderId;

    @ApiModelProperty(value = "经销商ID", required = false)
    private Long channelId;

    @ApiModelProperty(value = "订单状态", required = false)
    private Integer status;

    @ApiModelProperty(value = "收货人手机号", required = false)
    private String tel;

    @ApiModelProperty("供应商id")
    private Long supplierId;

    /**
     * 下单区间-开始时间
     */
    @ApiModelProperty(value = "开始时间", required = false)
    private Date startTime;

    /**
     * 下单区间-截止时间
     */
    @ApiModelProperty(value = "截止时间", required = false)
    private Date endTime;
}
