package com.qs.mp.admin.domain.param;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotNull;
import java.util.List;

/**
 * @author zhangkaikai
 * @create 2023-06-06 2:14 PM
 **/
@ApiModel("门店采购商品订单发货参数")
@Data
public class ChannelGoodsOrderShipParam {

    @ApiModelProperty(value = "订单编号", required = false)
    private String orderId;

    @NotNull(message = "配送类型不能为空")
    @ApiModelProperty(value = "配送类型 1快递 2 无需物流", required = false)
    private Integer deliveryType;

    /**
     * 物流公司ID
     */
    @NotNull(message = "快递公司不能为空")
    @ApiModelProperty(value = "物流公司", required = false)
    private Long deliveryId;

    /**
     * 物流单号ID
     */
    @NotNull(message = "物流单号不能为空")
    @ApiModelProperty(value = "物流单号", required = false)
    private String deliveryFlowId;

    @NotNull(message = "发货商品不能为空")
    @ApiModelProperty(value = "发货商品", required = false)
    private List<Long> itemIds;;
}
