package com.qs.mp.admin.domain.vo;

import com.alibaba.fastjson.annotation.JSONField;
import com.alibaba.fastjson.serializer.SerializerFeature;
import com.qs.mp.common.enums.CdKeyGroupStatusEnum;
import lombok.Data;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import java.util.Date;

/**
 * @author zhangkaikai
 * @create 2023-05-17 12:26 AM
 **/

@ApiModel("兑换码组列表出参类")
@Data
public class CdKeyGroupListVO {

    @ApiModelProperty("兑换码组id")
    private String groupId;

    @ApiModelProperty("兑换码数量")
    private Integer quantity;

    @ApiModelProperty("门店名称")
    private String siteName;

    @ApiModelProperty("添加时间")
    private Date createdTime;

    @ApiModelProperty("激活时间")
    private Date activationTime;

    @ApiModelProperty("状态,待生成waiting/未激活noactive/已生效activated/已失效invalid")
    @JSONField(serialzeFeatures = SerializerFeature.WriteEnumUsingToString)
    private CdKeyGroupStatusEnum status;

    @ApiModelProperty("兑换码")
    private String cdKey;

    @ApiModelProperty("商品名称")
    private String title;

    @ApiModelProperty("图片链接")
    private String picUrl;

}
