package com.qs.mp.admin.mapper;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.qs.mp.admin.domain.TicketAwardsPrize;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.qs.mp.admin.domain.TicketBox;
import com.qs.mp.admin.domain.vo.TicketAwardsPrizeVO;
import com.qs.mp.admin.domain.vo.TicketBoxGoodsListVO;

import java.util.List;
import org.apache.ibatis.annotations.Param;

/**
 * @auther quanshu
 * @create 2022-03-02 12:25:55
 * @describe 盲票盒奖项对应的奖品设置mapper类
 */
public interface TicketAwardsPrizeMapper extends BaseMapper<TicketAwardsPrize> {
  List<TicketAwardsPrizeVO> listPrizeVO(@Param(Constants.WRAPPER) Wrapper<TicketAwardsPrize> queryWrapper);

  /**
   * 根据条件查询奖品信息
   * @param queryWrapper
   * @return
   */
  List<TicketAwardsPrize> listByQueryWrapper(@Param(Constants.WRAPPER) QueryWrapper<TicketAwardsPrize> queryWrapper);

  List<TicketBox> listTicketDetailRelGoodsId(@Param(Constants.WRAPPER) QueryWrapper<TicketBoxGoodsListVO> queryWrapper);

  /**
   * 根据商品id查询关联盲票详细信息
   * @param goodsId
   * @return
   */
  List<TicketBox> listTicketDetailByGoodId(String goodsId);
}
