package com.qs.mp.admin.service;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.qs.mp.admin.domain.TicketAwardsPrize;
import com.baomidou.mybatisplus.extension.service.IService;
import com.qs.mp.admin.domain.TicketBox;
import com.qs.mp.admin.domain.vo.TicketAwardsPrizeVO;
import com.qs.mp.admin.domain.vo.TicketBoxGoodsListVO;

import java.util.List;

/**
 * <p>
 * 盲票盒奖项对应的奖品设置 服务类
 * </p>
 *
 * @author quanshu
 * @since 2022-03-02
 */
public interface ITicketAwardsPrizeService extends IService<TicketAwardsPrize> {
  List<TicketAwardsPrizeVO> listPrizeVO(Wrapper<TicketAwardsPrize> queryWrapper);

  List<TicketAwardsPrizeVO> listPrizeVO(String boxId);

  /**
   * 根据条件查询奖品信息
    * @param queryWrapper
   * @return
   */
    List<TicketAwardsPrize> listByQueryWrapper(QueryWrapper<TicketAwardsPrize> queryWrapper);

  List<TicketBox> listTicketDetailRelGoods(QueryWrapper<TicketBoxGoodsListVO> queryWrapper);

  /**
   * 根据商品id查询关联盲票详细信息
   * @param goodsId
   * @return
   */
  List<TicketBox> listTicketDetailByGoodId(String goodsId);

  /**
   * 根据盲票组id查询盲票组红包奖项
   * @param boxId
   * @return
   */
  List<TicketAwardsPrizeVO> listPrizeByBoxIdVO(String boxId);
}
