package com.qs.mp.channel.domain;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.Serializable;
import java.util.Date;
import lombok.Data;

/**
 * @describe 渠道银行卡信息实体类
 * @auther quanshu
 * @create 2022-03-04 17:11:47
 */
@TableName("mp_channel_bank_card")
@Data
@ApiModel("渠道银行卡实体类")
public class ChannelBankCard implements Serializable {

  private static final long serialVersionUID = 1L;

  @ApiModelProperty("id")
  @TableId(value = "id" , type = IdType.AUTO)
  private Long id;

  /**
   * 渠道id
   */
  @ApiModelProperty("渠道id")
  @TableField("channel_id")
  private Long channelId;

  /**
   * 持卡人
   */
  @ApiModelProperty("持卡人名字")
  @TableField("user_name")
  private String userName;

//  @ApiModelProperty("身份证号")
//  @TableField("id_card")
//  private String idCard;

  /**
   * 卡号
   */
  @ApiModelProperty("卡号")
  @TableField("card_no")
  private String cardNo;

  /**
   * 银行卡所属银行
   */
  @ApiModelProperty("所属银行")
  @TableField("bank_name")
  private String bankName;

  /**
   * 开户行
   */
  @ApiModelProperty("开户行")
  @TableField("branch_name")
  private String branchName;

  /**
   * 预留手机号码
   */
  @ApiModelProperty("预留手机号")
  @TableField("mobile")
  private String mobile;

  /**
   * 1默认
   */
  @ApiModelProperty("1默认卡")
  @TableField("default_card")
  private Integer defaultCard;

  /**
   * 添加时间
   */
  @ApiModelProperty("创建时间")
  @TableField("create_time")
  private Date createTime;

  /**
   * 修改时间
   */
  @ApiModelProperty("更新时间")
  @TableField("update_time")
  private Date updateTime;

//  @ApiModelProperty("逻辑删除")
//  @TableLogic
//  @TableField("is_deleted")
//  private Integer isDeleted;


}
