package com.qs.mp.channel.domain;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableField;
import java.io.Serializable;
import com.baomidou.mybatisplus.annotation.*;
import lombok.Data;

/**
 * @describe 经销商商品采购订单明细实体类
 * @auther quanshu
 * @create 2023-06-07 01:21:14
 */
@TableName("mp_channel_goods_order_item")
@Data
public class ChannelGoodsOrderItem implements Serializable {
    private static final long serialVersionUID = 1L;

        /**
     * 主键
     */
         @TableId(value = "item_id", type = IdType.AUTO)
    private Long itemId;

        /**
     * 渠道ID
     */
         @TableField("channel_id")
    private Long channelId;

        /**
     * 订单ID
     */
         @TableField("order_id")
    private String orderId;

        /**
     * 商品ID
     */
         @TableField("goods_id")
    private Long goodsId;

        /**
     * sku ID
     */
         @TableField("sku_id")
    private Long skuId;

        /**
     * sku 属性
     */
         @TableField("properties")
    private String properties;

        /**
     * 商品标题
     */
         @TableField("title")
    private String title;

        /**
     * 商品图片
     */
         @TableField("pic_url")
    private String picUrl;

        /**
     * 商品数量
     */
         @TableField("goods_num")
    private Integer goodsNum;

        /**
     * 供应商id
     */
         @TableField("supplier_id")
    private Long supplierId;

        /**
     * 创建时间
     */
         @TableField("created_time")
    private Date createdTime;

        /**
     * 更新时间
     */
         @TableField("updated_time")
    private Date updatedTime;


}