package com.qs.mp.channel.domain.param;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import javax.validation.constraints.NotBlank;
import lombok.Data;

/**
 * 渠道银行卡创建入参类
 * @author Evan
 * @date 2023/3/30
 */
@ApiModel("渠道银行卡创建入参类")
@Data
public class ChannelBankCardCreateParam {

    @NotBlank(message = "姓名不内外空")
    @ApiModelProperty("用户名称")
    private String userName;

    @NotBlank(message = "身份证号不能为空")
    @ApiModelProperty("身份证号")
    private String idCard;

    @NotBlank(message = "银行名称不能为空")
    @ApiModelProperty("银行名称")
    private String bankName;

    @NotBlank(message = "银行卡号不能为空")
    @ApiModelProperty("银行卡号")
    private String cardNo;


}
