package com.qs.mp.channel.domain.param;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import java.math.BigDecimal;

import javax.validation.constraints.NotNull;

import com.qs.mp.common.enums.SiteTypeEnum;

import lombok.Data;

@ApiModel(value= "地址参数")
@Data
public class VerifyParam {

	@NotNull(message = "渠道ID不能为空")
	@ApiModelProperty(value = "渠道ID",required=true)
	private Long channelId;

	@NotNull(message = "联系人不能为空")
	@ApiModelProperty(value = "联系人",required=true)
	private String contact;

	@NotNull(message = "手机号码不能为空")
	@ApiModelProperty(value = "手机号码", required = true)
	private String mobile;

//	@NotNull(message = "门店类型不能为空")
	@ApiModelProperty(value = "门店类型", required = false)
	private SiteTypeEnum siteType;

	@NotNull(message = "门店名称不能为空")
	@ApiModelProperty(value = "门店名称",required=true)
	private String siteName;

	@NotNull(message = "省ID不能为空")
	@ApiModelProperty(value = "省ID",required=true)
	private Long provinceId;

	@NotNull(message = "城市ID不能为空")
	@ApiModelProperty(value = "城市ID",required=true)
	private Long cityId;

	@NotNull(message = "区ID不能为空")
	@ApiModelProperty(value = "区ID",required=true)
	private Long areaId;

	@NotNull(message = "省不能为空")
	@ApiModelProperty(value = "省",required=true)
	private String province;

	@NotNull(message = "城市不能为空")
	@ApiModelProperty(value = "城市",required=true)
	private String city;

	@NotNull(message = "区不能为空")
	@ApiModelProperty(value = "区",required=true)
	private String area;

	@NotNull(message = "详细地址不能为空")
	@ApiModelProperty(value = "详细地址",required=true)
	private String address;

//	@NotNull(message = "营业执照不能为空")
@ApiModelProperty(value = "营业执照",required=false)
private String bizLicensePic;

//	@NotNull(message = "门店照片不能为空")
@ApiModelProperty(value = "门店照片",required=false)
private String doorPic;

}
