package com.qs.mp.channel.domain.vo;

import com.qs.mp.user.domain.UserAddr;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * @author zhangkaikai
 * @create 2023-06-04 11:18 PM
 **/
@ApiModel("门店商品订单结算出参类")
@Data
public class ChannelGoodsOrderSettleVO {

    @ApiModelProperty("用户地址")
    private UserAddr addr;

    /**
     * 订单金额
     */
    @ApiModelProperty("订单金额")
    private Integer orderAmt = 0;

    /**
     * 实付金额
     */
    @ApiModelProperty("实付金额")
    private Integer payAmt = 0;

    /**
     * 运费金额
     */
    @ApiModelProperty("运费金额")
    private Integer freightAmt = 0;

    @ApiModelProperty("运费模板类型 1发货，2不发货")
    private Integer freightType;

    @ApiModelProperty("运费备注")
    private String freightRemark;

    /**
     * 单价
     */
    @ApiModelProperty("单价")
    private Integer price;

    /**
     * 商品id
     */
    @ApiModelProperty("商品id")
    private Long goodsId;

    /**
     * 购买数量
     */
    @ApiModelProperty("购买数量")
    private Integer orderNum;
}
