package com.qs.mp.common.domain;

import com.alibaba.fastjson.annotation.JSONField;
import com.alibaba.fastjson.serializer.SerializerFeature;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.qs.mp.common.enums.YsCallBizTypeEnum;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableField;
import java.io.Serializable;
import com.baomidou.mybatisplus.annotation.*;
import lombok.Data;

/**
 * @describe 银盛调用日志表实体类
 * @auther quanshu
 * @create 2023-03-27 14:24:03
 */
@TableName("mp_ys_call_log")
@Data
@ApiModel("银盛调用日志实体类")
public class YsCallLog implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 主键
     */
    @ApiModelProperty("主键")
    @TableId(value = "id", type = IdType.AUTO)
    private Long id;

    /**
     * 请求id
     */
    @ApiModelProperty("关联id")
    @TableField("biz_id")
    private String bizId;

    @ApiModelProperty("关联业务")
    @TableField("biz_Type")
    @JSONField(serialzeFeatures = SerializerFeature.WriteEnumUsingToString)
    private YsCallBizTypeEnum bizType;

    /**
     * 请求接口
     */
    @ApiModelProperty("请求接口")
    @TableField("interface_id")
    private String interfaceId;

    /**
     * 请求参数
     */
    @ApiModelProperty("请求参数")
    @TableField("req_json")
    private String reqJson;

    /**
     * 响应参数
     */
    @ApiModelProperty("响应参数")
    @TableField("res_json")
    private String resJson;

    @ApiModelProperty("回调数据")
    @TableField("callback_json")
    private String callbackJson;

    /**
     * 创建时间
     */
    @ApiModelProperty("创建时间")
    @TableField("created_time")
    private Date createdTime;

    /**
     * 更新时间
     */
    @ApiModelProperty("更新时间")
    @TableField("updated_time")
    private Date updatedTime;

    /**
     * 逻辑删除标识
     */
    @ApiModelProperty("逻辑删除标识")
    @TableField("is_deleted")
    @TableLogic
    private Integer isDeleted;


}