package com.qs.mp.pay.domain;

import com.alibaba.fastjson.annotation.JSONField;
import com.alibaba.fastjson.serializer.SerializerFeature;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.qs.mp.common.enums.DivisionStatusEnum;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableField;
import java.io.Serializable;
import com.baomidou.mybatisplus.annotation.*;
import lombok.Data;

/**
 * @describe 分账记录表实体类
 * @auther quanshu
 * @create 2023-03-27 14:24:26
 */
@TableName("mp_division_log")
@Data
@ApiModel("分账记录表实体类")
public class DivisionLog implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 主键
     */
    @ApiModelProperty("主键")
    @TableId(value = "id", type = IdType.AUTO)
    private Long id;

    /**
     * 分账单号
     */
    @ApiModelProperty("分账单号")
    @TableField("trade_no")
    private String tradeNo;

    /**
     * 关联支付单号
     */
    @ApiModelProperty("关联支付单号")
    @TableField("order_no")
    private String orderNo;

    /**
     * 关联业务单号
     */
    @ApiModelProperty("关联业务单号")
    @TableField("biz_id")
    private String bizId;

    /**
     * 分账金额
     */
    @ApiModelProperty("分账金额")
    @TableField("amount")
    private Integer amount;

    /**
     * 状态:1初始化,2完成,3失败
     */
    @ApiModelProperty("状态:0初始化,1完成,2登记失败,3失败")
    @TableField("status")
    @JSONField(serialzeFeatures = SerializerFeature.WriteEnumUsingToString)
    private DivisionStatusEnum status;

    /**
     * 创建时间
     */
    @ApiModelProperty("创建时间")
    @TableField("created_time")
    private Date createdTime;

    /**
     * 更新时间
     */
    @ApiModelProperty("更新时间")
    @TableField("updated_time")
    private Date updatedTime;

    /**
     * 逻辑删除标识
     */
    @ApiModelProperty("逻辑删除标识")
    @TableField("is_deleted")
    @TableLogic
    private Integer isDeleted;


}