package com.qs.mp.user.domain.vo;

import com.alibaba.fastjson.annotation.JSONField;
import com.alibaba.fastjson.serializer.SerializerFeature;
import com.qs.mp.common.enums.TicketPrizeTypeEnum;
import com.qs.mp.user.domain.UserHitPrize;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * @author zhangkaikai
 * @create 2023-05-31 6:00 PM
 **/
@ApiModel("用户中奖信息")
@Data
public class UserHitPrizeVO extends UserHitPrize {

    @ApiModelProperty("奖品类型 1 实物商品 2优惠券 3平台代币")
    @JSONField(serialzeFeatures = SerializerFeature.WriteEnumUsingToString)
    private TicketPrizeTypeEnum prizeType;

    @ApiModelProperty("奖品价值")
    private Integer value;

    @ApiModelProperty("中奖奖品所属票组")
    private String boxId;

    @ApiModelProperty("关联id，goodsId，couponId")
    private String refId;
}
