package com.qs.mp.user.mapper;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.qs.mp.user.domain.UserHitPrize;
import com.qs.mp.user.domain.UserPrizeStorage;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.qs.mp.user.domain.UserTicketOrderItem;
import com.qs.mp.user.domain.vo.UserPrizeStorageVO;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * @auther quanshu
 * @create 2022-03-07 20:45:43
 * @describe 用户实物奖品仓库mapper类
 */
public interface UserPrizeStorageMapper extends BaseMapper<UserPrizeStorage> {

    /**
     * 根据条件查询用户奖品库信息
     * @param queryWrapper
     * @return
     */
    List<UserPrizeStorageVO> listByQueryWrapper(@Param(Constants.WRAPPER) QueryWrapper<UserPrizeStorage> queryWrapper);

    List<UserPrizeStorageVO> listGoodsPrizeCost(@Param(Constants.WRAPPER) QueryWrapper<UserHitPrize> queryWrapper);

    List<UserPrizeStorageVO> listAllPrizeStorageGoodsCost(@Param(Constants.WRAPPER) QueryWrapper<UserPrizeStorage> queryWrapper);

    List<UserPrizeStorageVO> listTicketGoodsCost(@Param(Constants.WRAPPER) QueryWrapper<UserTicketOrderItem> queryWrapper);
}
